//
//  AppDelegate.swift
//  zip_app
//
//  Created by Michiyuki Abe on 2018/12/28.
//  Copyright © 2018 zip_pro. All rights reserved.
//

import Cocoa

@NSApplicationMain
class AppDelegate: NSObject, NSApplicationDelegate {
    
    func applicationDidFinishLaunching(_ aNotification: Notification) {
        // Insert code here to initialize your application
        let defaults = UserDefaults.standard
        
        // for debug
//        defaults.removeObject(forKey: "firstStartedAt")
//        defaults.removeObject(forKey: "token")
//        defaults.removeObject(forKey: "settings")

        if
            defaults.integer(forKey: "firstStartedAt") == nil ||
            defaults.integer(forKey: "firstStartedAt") == 0
        {
            defaults.set(Int64(NSDate().timeIntervalSince1970), forKey: "firstStartedAt")
        }
    }
    
    func applicationWillTerminate(_ aNotification: Notification) {
        // Insert code here to tear down your application
    }
    
    func application(_ sender: NSApplication, openFiles filenames: [String]) {
        let _savePath: String = URL(fileURLWithPath: filenames[0]).deletingLastPathComponent().path
        let settings = (UserDefaults.standard.dictionary(forKey: "settings") != nil) ? Util().loadSettings() : SettingStatus()
        
        // 認証済み確認し、未認証であれば認証用アラートを表示
        if Util().loadToken() == nil {
            let array = NSApplication.shared.windows
            for var window in array {
                if window.isMainWindow {
                    Util().showAuthAlert(window: window)
                    break
                }
            }
            return
        }
        
        ZipAction().createZipEntry(
            targetFilePaths: filenames,
            savePath: _savePath,
            settingStatus: settings
        )
    }
}
