//
//  FileDragDropImageView.swift
//  zip_app
//
//  Created by Ikeyatsu Shota on 2019/01/11.
//  Copyright © 2019 zip_pro. All rights reserved.
//

import Cocoa

class FileDragDropTopLayerView: NSView {

    var delegate: DragAndDropDelegate?
    
    override func draw(_ dirtyRect: NSRect) {
        super.draw(dirtyRect)
        // Drawing code here.
    }
    
    override init(frame frameRect: NSRect) {
        super.init(frame: frameRect)
        mInit()
    }
    
    required init?(coder: NSCoder) {
        super.init(coder: coder)
        mInit()
    }
    
    func mInit() {
        registerForDraggedTypes([NSPasteboard.PasteboardType.fileURL])
    }
    
    override func draggingEntered(_ sender: NSDraggingInfo) -> NSDragOperation {
        return NSDragOperation.copy
    }
    
    override func updateDraggingItemsForDrag(_ sender: NSDraggingInfo?) {
        print("on drag before drop")
        if let mDelegate = self.delegate {
            mDelegate.onDrag()
        }
    }

    override func draggingExited(_ sender: NSDraggingInfo?) {
        print("off drag before drop")
        if let mDelegate = self.delegate {
            mDelegate.offDrag()
        }
    }
    
    override func prepareForDragOperation(_ sender: NSDraggingInfo) -> Bool {
        // performDragOperationの前の処理
        return true
    }
    
    override func performDragOperation(_ sender: NSDraggingInfo) -> Bool {
        if let mDelegate = self.delegate {
            mDelegate.onDragAndDrop(sender: sender)
        }   
        return true
    }
    
}
